# frozen_string_literal: true

require 'zip'

module Docx
  module Encoder
    def self.build_new_document_xml(original_document, new_document_sections)
        output = Zip::OutputStream.write_buffer(StringIO.new) do |out|
            original_document.each do |entry|
                entry_name = entry.name
                out.put_next_entry(entry_name)
                out.write(new_document_sections[entry_name] || entry.get_input_stream.read)
            end
        end
        output.string
    end
  end
end
