require_relative 'cleaners'

class XmlProcessor
    BROKEN_VARIABLE_PATTERN = "<w:t>([^\#^<^>]*?)#([^\#^<^>]*?)<\/w:t>"

    def self.clean_variables(document)
        document.gsub(/\{\{.*?\}\}/m) do |match|
            ret = match.include?('>') ? join_variable_tags(match) : match
            ret = clean_spaces_inside_variables(ret)
            ret
        end
    end

    def self.join_variable_tags(match)
        before = match.gsub(/\<(.*)/m, '')
        inside = match.scan(/<w:t.*?>([^>]*?)<.w:t>/m).join(' ').gsub(/\s*\.\s*/, '.')
        after = match.gsub(/.*>([^>]+)$/m, "\\1")
        [before, inside, after].join(' ')
    end

    def self.clean_spaces_inside_variables(match)
        ret = match.dup
        cleaner_methods = Cleaners.methods.grep /_cleaner/
        cleaner_methods.each do |clean_method|
            ret = Cleaners.send(clean_method, ret)
        end
        puts "Returning cleaned variable: #{ret}"
        ret
    end
end

# {{% devedor[:pessoa_fisica][:cedula_identidade] %}}, 